package fucoin.wallet;

import akka.actor.ActorRef;
import akka.japi.Creator;
import fucoin.gui.WalletGuiController;
import fucoin.gui.WalletGuiControllerImpl;

public class WalletFactory implements Creator<AbstractWallet> {

    private ActorRef preknownNeighbour;
    private String walletName;
    private ActorRef remoteSuperVisorActor;
    private String preknownNeighbourName;

    public WalletFactory(ActorRef preknownNeighbour, String preknownNeighbourName, String walletName, ActorRef remoteSuperVisorActor) {
        this.preknownNeighbour = preknownNeighbour;
        this.preknownNeighbourName = preknownNeighbourName;
        this.walletName = walletName;
        this.remoteSuperVisorActor = remoteSuperVisorActor;

    }

    @Override
    public WalletImpl create() throws Exception {
        WalletImpl wallet = new WalletImpl(preknownNeighbour, preknownNeighbourName, walletName, remoteSuperVisorActor);

        WalletGuiController gui = new WalletGuiControllerImpl(wallet);
        wallet.setGui(gui);
        return wallet;
    }
}
